<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: proto/table.proto

namespace Keboola\StorageDriver\Command\Table;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 **
 * Command is used when export file from Keboola connection
 * Command will take backend table and export it into destination file based on provided options
 *
 * Generated from protobuf message <code>keboola.storageDriver.command.table.TableExportToFileCommand</code>
 */
class TableExportToFileCommand extends \Google\Protobuf\Internal\Message
{
    /**
     * Source table on the backend
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.Table source = 1;</code>
     */
    protected $source = null;
    /**
     * Type of file storage provider
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileProvider fileProvider = 2;</code>
     */
    protected $fileProvider = 0;
    /**
     * Specifies the format of the data files containing source data
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileFormat fileFormat = 3;</code>
     */
    protected $fileFormat = 0;
    /**
     * path to file on cloud storage
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FilePath filePath = 4;</code>
     */
    protected $filePath = null;
    /**
     **
     * credentials used to access file on file storage
     * Use ImportExportShared.{S3Credentials, ABSCredentials}
     *
     * Generated from protobuf field <code>.google.protobuf.Any fileCredentials = 5;</code>
     */
    protected $fileCredentials = null;
    /**
     **
     * Export options may vary based on backend
     * based on:
     * https://github.com/keboola/php-db-import-export/blob/master/src/ExportOptions.php
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.ExportOptions exportOptions = 6;</code>
     */
    protected $exportOptions = null;
    /**
     * additional export data specific for backend
     *
     * Generated from protobuf field <code>.google.protobuf.Any meta = 7;</code>
     */
    protected $meta = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Keboola\StorageDriver\Command\Table\ImportExportShared\Table $source
     *           Source table on the backend
     *     @type int $fileProvider
     *           Type of file storage provider
     *     @type int $fileFormat
     *           Specifies the format of the data files containing source data
     *     @type \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath $filePath
     *           path to file on cloud storage
     *     @type \Google\Protobuf\Any $fileCredentials
     *          *
     *           credentials used to access file on file storage
     *           Use ImportExportShared.{S3Credentials, ABSCredentials}
     *     @type \Keboola\StorageDriver\Command\Table\ImportExportShared\ExportOptions $exportOptions
     *          *
     *           Export options may vary based on backend
     *           based on:
     *           https://github.com/keboola/php-db-import-export/blob/master/src/ExportOptions.php
     *     @type \Google\Protobuf\Any $meta
     *           additional export data specific for backend
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Proto\Table::initOnce();
        parent::__construct($data);
    }

    /**
     * Source table on the backend
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.Table source = 1;</code>
     * @return \Keboola\StorageDriver\Command\Table\ImportExportShared\Table|null
     */
    public function getSource()
    {
        return $this->source;
    }

    public function hasSource()
    {
        return isset($this->source);
    }

    public function clearSource()
    {
        unset($this->source);
    }

    /**
     * Source table on the backend
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.Table source = 1;</code>
     * @param \Keboola\StorageDriver\Command\Table\ImportExportShared\Table $var
     * @return $this
     */
    public function setSource($var)
    {
        GPBUtil::checkMessage($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\Table::class);
        $this->source = $var;

        return $this;
    }

    /**
     * Type of file storage provider
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileProvider fileProvider = 2;</code>
     * @return int
     */
    public function getFileProvider()
    {
        return $this->fileProvider;
    }

    /**
     * Type of file storage provider
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileProvider fileProvider = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setFileProvider($var)
    {
        GPBUtil::checkEnum($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\FileProvider::class);
        $this->fileProvider = $var;

        return $this;
    }

    /**
     * Specifies the format of the data files containing source data
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileFormat fileFormat = 3;</code>
     * @return int
     */
    public function getFileFormat()
    {
        return $this->fileFormat;
    }

    /**
     * Specifies the format of the data files containing source data
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileFormat fileFormat = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setFileFormat($var)
    {
        GPBUtil::checkEnum($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\FileFormat::class);
        $this->fileFormat = $var;

        return $this;
    }

    /**
     * path to file on cloud storage
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FilePath filePath = 4;</code>
     * @return \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath|null
     */
    public function getFilePath()
    {
        return $this->filePath;
    }

    public function hasFilePath()
    {
        return isset($this->filePath);
    }

    public function clearFilePath()
    {
        unset($this->filePath);
    }

    /**
     * path to file on cloud storage
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FilePath filePath = 4;</code>
     * @param \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath $var
     * @return $this
     */
    public function setFilePath($var)
    {
        GPBUtil::checkMessage($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath::class);
        $this->filePath = $var;

        return $this;
    }

    /**
     **
     * credentials used to access file on file storage
     * Use ImportExportShared.{S3Credentials, ABSCredentials}
     *
     * Generated from protobuf field <code>.google.protobuf.Any fileCredentials = 5;</code>
     * @return \Google\Protobuf\Any|null
     */
    public function getFileCredentials()
    {
        return $this->fileCredentials;
    }

    public function hasFileCredentials()
    {
        return isset($this->fileCredentials);
    }

    public function clearFileCredentials()
    {
        unset($this->fileCredentials);
    }

    /**
     **
     * credentials used to access file on file storage
     * Use ImportExportShared.{S3Credentials, ABSCredentials}
     *
     * Generated from protobuf field <code>.google.protobuf.Any fileCredentials = 5;</code>
     * @param \Google\Protobuf\Any $var
     * @return $this
     */
    public function setFileCredentials($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Any::class);
        $this->fileCredentials = $var;

        return $this;
    }

    /**
     **
     * Export options may vary based on backend
     * based on:
     * https://github.com/keboola/php-db-import-export/blob/master/src/ExportOptions.php
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.ExportOptions exportOptions = 6;</code>
     * @return \Keboola\StorageDriver\Command\Table\ImportExportShared\ExportOptions|null
     */
    public function getExportOptions()
    {
        return $this->exportOptions;
    }

    public function hasExportOptions()
    {
        return isset($this->exportOptions);
    }

    public function clearExportOptions()
    {
        unset($this->exportOptions);
    }

    /**
     **
     * Export options may vary based on backend
     * based on:
     * https://github.com/keboola/php-db-import-export/blob/master/src/ExportOptions.php
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.ExportOptions exportOptions = 6;</code>
     * @param \Keboola\StorageDriver\Command\Table\ImportExportShared\ExportOptions $var
     * @return $this
     */
    public function setExportOptions($var)
    {
        GPBUtil::checkMessage($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\ExportOptions::class);
        $this->exportOptions = $var;

        return $this;
    }

    /**
     * additional export data specific for backend
     *
     * Generated from protobuf field <code>.google.protobuf.Any meta = 7;</code>
     * @return \Google\Protobuf\Any|null
     */
    public function getMeta()
    {
        return $this->meta;
    }

    public function hasMeta()
    {
        return isset($this->meta);
    }

    public function clearMeta()
    {
        unset($this->meta);
    }

    /**
     * additional export data specific for backend
     *
     * Generated from protobuf field <code>.google.protobuf.Any meta = 7;</code>
     * @param \Google\Protobuf\Any $var
     * @return $this
     */
    public function setMeta($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Any::class);
        $this->meta = $var;

        return $this;
    }

}

